diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/class-phpmailer.php ./wordpress-3.4/wp-includes/class-phpmailer.php
*** ./wordpress-3.3.2/wp-includes/class-phpmailer.php	2011-06-01 15:42:47.000000000 -0500
--- ./wordpress-3.4/wp-includes/class-phpmailer.php	2012-05-03 11:41:59.000000000 -0500
***************
*** 1206,1231 ****
          $body .= $this->LE.$this->LE;
          $body .= $this->EndBoundary($this->boundary[1]);
          break;
!       case 'plain':
          $body .= $this->EncodeString($this->Body, $this->Encoding);
          break;
!       case 'attachments':
!         $body .= $this->GetBoundary($this->boundary[1], '', '', '');
          $body .= $this->EncodeString($this->Body, $this->Encoding);
          $body .= $this->LE;
!         $body .= $this->AttachAll();
          break;
!       case 'alt_attachments':
!         $body .= sprintf("--%s%s", $this->boundary[1], $this->LE);
!         $body .= sprintf("Content-Type: %s;%s" . "\tboundary=\"%s\"%s", 'multipart/alternative', $this->LE, $this->boundary[2], $this->LE.$this->LE);
!         $body .= $this->GetBoundary($this->boundary[2], '', 'text/plain', '') . $this->LE; // Create text body
          $body .= $this->EncodeString($this->AltBody, $this->Encoding);
          $body .= $this->LE.$this->LE;
!         $body .= $this->GetBoundary($this->boundary[2], '', 'text/html', '') . $this->LE; // Create the HTML body
          $body .= $this->EncodeString($this->Body, $this->Encoding);
          $body .= $this->LE.$this->LE;
          $body .= $this->EndBoundary($this->boundary[2]);
!         $body .= $this->AttachAll();
          break;
      }
  
--- 1347,1402 ----
          $body .= $this->LE.$this->LE;
          $body .= $this->EndBoundary($this->boundary[1]);
          break;
!       case 'alt_inline':
!         $body .= $this->GetBoundary($this->boundary[1], '', 'text/plain', '');
!         $body .= $this->EncodeString($this->AltBody, $this->Encoding);
!         $body .= $this->LE.$this->LE;
!         $body .= $this->TextLine("--" . $this->boundary[1]);
!         $body .= $this->HeaderLine('Content-Type', 'multipart/related;');
!         $body .= $this->TextLine("\tboundary=\"" . $this->boundary[2] . '"');
!         $body .= $this->LE;
!         $body .= $this->GetBoundary($this->boundary[2], '', 'text/html', '');
          $body .= $this->EncodeString($this->Body, $this->Encoding);
+         $body .= $this->LE.$this->LE;
+         $body .= $this->AttachAll("inline", $this->boundary[2]);
+         $body .= $this->LE;
+         $body .= $this->EndBoundary($this->boundary[1]);
          break;
!       case 'alt_attach':
!         $body .= $this->TextLine("--" . $this->boundary[1]);
!         $body .= $this->HeaderLine('Content-Type', 'multipart/alternative;');
!         $body .= $this->TextLine("\tboundary=\"" . $this->boundary[2] . '"');
!         $body .= $this->LE;
!         $body .= $this->GetBoundary($this->boundary[2], '', 'text/plain', '');
!         $body .= $this->EncodeString($this->AltBody, $this->Encoding);
!         $body .= $this->LE.$this->LE;
!         $body .= $this->GetBoundary($this->boundary[2], '', 'text/html', '');
          $body .= $this->EncodeString($this->Body, $this->Encoding);
+         $body .= $this->LE.$this->LE;
+         $body .= $this->EndBoundary($this->boundary[2]);
          $body .= $this->LE;
!         $body .= $this->AttachAll("attachment", $this->boundary[1]);
          break;
!       case 'alt_inline_attach':
!         $body .= $this->TextLine("--" . $this->boundary[1]);
!         $body .= $this->HeaderLine('Content-Type', 'multipart/alternative;');
!         $body .= $this->TextLine("\tboundary=\"" . $this->boundary[2] . '"');
!         $body .= $this->LE;
!         $body .= $this->GetBoundary($this->boundary[2], '', 'text/plain', '');
          $body .= $this->EncodeString($this->AltBody, $this->Encoding);
          $body .= $this->LE.$this->LE;
!         $body .= $this->TextLine("--" . $this->boundary[2]);
!         $body .= $this->HeaderLine('Content-Type', 'multipart/related;');
!         $body .= $this->TextLine("\tboundary=\"" . $this->boundary[3] . '"');
!         $body .= $this->LE;
!         $body .= $this->GetBoundary($this->boundary[3], '', 'text/html', '');
          $body .= $this->EncodeString($this->Body, $this->Encoding);
          $body .= $this->LE.$this->LE;
+         $body .= $this->AttachAll("inline", $this->boundary[3]);
+         $body .= $this->LE;
          $body .= $this->EndBoundary($this->boundary[2]);
!         $body .= $this->LE;
!         $body .= $this->AttachAll("attachment", $this->boundary[1]);
          break;
      }
  
***************
*** 1238,1245 ****
          $signed = tempnam("", "signed");
          if (@openssl_pkcs7_sign($file, $signed, "file://".$this->sign_cert_file, array("file://".$this->sign_key_file, $this->sign_key_pass), NULL)) {
            @unlink($file);
-           @unlink($signed);
            $body = file_get_contents($signed);
          } else {
            @unlink($file);
            @unlink($signed);
--- 1409,1416 ----
          $signed = tempnam("", "signed");
          if (@openssl_pkcs7_sign($file, $signed, "file://".$this->sign_cert_file, array("file://".$this->sign_key_file, $this->sign_key_pass), NULL)) {
            @unlink($file);
            $body = file_get_contents($signed);
+           @unlink($signed);
          } else {
            @unlink($file);
            @unlink($signed);
***************
*** 1258,1266 ****
  
    /**
     * Returns the start of a message boundary.
!    * @access private
     */
!   private function GetBoundary($boundary, $charSet, $contentType, $encoding) {
      $result = '';
      if($charSet == '') {
        $charSet = $this->CharSet;
--- 1429,1438 ----
  
    /**
     * Returns the start of a message boundary.
!    * @access protected
!    * @return string
     */
!   protected function GetBoundary($boundary, $charSet, $contentType, $encoding) {
      $result = '';
      if($charSet == '') {
        $charSet = $this->CharSet;
***************
*** 1272,1278 ****
        $encoding = $this->Encoding;
      }
      $result .= $this->TextLine('--' . $boundary);
!     $result .= sprintf("Content-Type: %s; charset = \"%s\"", $contentType, $charSet);
      $result .= $this->LE;
      $result .= $this->HeaderLine('Content-Transfer-Encoding', $encoding);
      $result .= $this->LE;
--- 1444,1450 ----
        $encoding = $this->Encoding;
      }
      $result .= $this->TextLine('--' . $boundary);
!     $result .= sprintf("Content-Type: %s; charset=\"%s\"", $contentType, $charSet);
      $result .= $this->LE;
      $result .= $this->HeaderLine('Content-Transfer-Encoding', $encoding);
      $result .= $this->LE;
***************
*** 1282,1312 ****
  
    /**
     * Returns the end of a message boundary.
!    * @access private
     */
!   private function EndBoundary($boundary) {
      return $this->LE . '--' . $boundary . '--' . $this->LE;
    }
  
    /**
     * Sets the message type.
!    * @access private
     * @return void
     */
!   private function SetMessageType() {
!     if(count($this->attachment) < 1 && strlen($this->AltBody) < 1) {
!       $this->message_type = 'plain';
!     } else {
!       if(count($this->attachment) > 0) {
!         $this->message_type = 'attachments';
!       }
!       if(strlen($this->AltBody) > 0 && count($this->attachment) < 1) {
!         $this->message_type = 'alt';
!       }
!       if(strlen($this->AltBody) > 0 && count($this->attachment) > 0) {
!         $this->message_type = 'alt_attachments';
!       }
!     }
    }
  
    /**
--- 1454,1478 ----
  
    /**
     * Returns the end of a message boundary.
!    * @access protected
!    * @return string
     */
!   protected function EndBoundary($boundary) {
      return $this->LE . '--' . $boundary . '--' . $this->LE;
    }
  
    /**
     * Sets the message type.
!    * @access protected
     * @return void
     */
!   protected function SetMessageType() {
!     $this->message_type = array();
!     if($this->AlternativeExists()) $this->message_type[] = "alt";
!     if($this->InlineImageExists()) $this->message_type[] = "inline";
!     if($this->AttachmentExists()) $this->message_type[] = "attach";
!     $this->message_type = implode("_", $this->message_type);
!     if($this->message_type == "") $this->message_type = "plain";
    }
  
    /**
***************
*** 1367,1373 ****
        if ($this->exceptions) {
          throw $e;
        }
!       echo $e->getMessage()."\n";
        if ( $e->getCode() == self::STOP_CRITICAL ) {
          return false;
        }
--- 1533,1541 ----
        if ($this->exceptions) {
          throw $e;
        }
! 	  if ($this->SMTPDebug) {
!         echo $e->getMessage()."\n";
!       }
        if ( $e->getCode() == self::STOP_CRITICAL ) {
          return false;
        }
***************
*** 1386,1395 ****
    /**
     * Attaches all fs, string, and binary attachments to the message.
     * Returns an empty string on failure.
!    * @access private
     * @return string
     */
!   private function AttachAll() {
      // Return text of body
      $mime = array();
      $cidUniq = array();
--- 1554,1563 ----
    /**
     * Attaches all fs, string, and binary attachments to the message.
     * Returns an empty string on failure.
!    * @access protected
     * @return string
     */
!   protected function AttachAll($disposition_type, $boundary) {
      // Return text of body
      $mime = array();
      $cidUniq = array();
***************
*** 1397,1450 ****
  
      // Add all attachments
      foreach ($this->attachment as $attachment) {
!       // Check for string attachment
!       $bString = $attachment[5];
!       if ($bString) {
!         $string = $attachment[0];
!       } else {
!         $path = $attachment[0];
!       }
! 
!       if (in_array($attachment[0], $incl)) { continue; }
!       $filename    = $attachment[1];
!       $name        = $attachment[2];
!       $encoding    = $attachment[3];
!       $type        = $attachment[4];
!       $disposition = $attachment[6];
!       $cid         = $attachment[7];
!       $incl[]      = $attachment[0];
!       if ( $disposition == 'inline' && isset($cidUniq[$cid]) ) { continue; }
!       $cidUniq[$cid] = true;
! 
!       $mime[] = sprintf("--%s%s", $this->boundary[1], $this->LE);
!       $mime[] = sprintf("Content-Type: %s; name=\"%s\"%s", $type, $this->EncodeHeader($this->SecureHeader($name)), $this->LE);
!       $mime[] = sprintf("Content-Transfer-Encoding: %s%s", $encoding, $this->LE);
! 
!       if($disposition == 'inline') {
!         $mime[] = sprintf("Content-ID: <%s>%s", $cid, $this->LE);
!       }
! 
!       $mime[] = sprintf("Content-Disposition: %s; filename=\"%s\"%s", $disposition, $this->EncodeHeader($this->SecureHeader($name)), $this->LE.$this->LE);
! 
!       // Encode as string attachment
!       if($bString) {
!         $mime[] = $this->EncodeString($string, $encoding);
!         if($this->IsError()) {
!           return '';
          }
!         $mime[] = $this->LE.$this->LE;
!       } else {
!         $mime[] = $this->EncodeFile($path, $encoding);
!         if($this->IsError()) {
!           return '';
          }
-         $mime[] = $this->LE.$this->LE;
        }
      }
  
!     $mime[] = sprintf("--%s--%s", $this->boundary[1], $this->LE);
  
!     return join('', $mime);
    }
  
    /**
--- 1565,1622 ----
  
      // Add all attachments
      foreach ($this->attachment as $attachment) {
!       // CHECK IF IT IS A VALID DISPOSITION_FILTER
!       if($attachment[6] == $disposition_type) {
!         // Check for string attachment
!         $bString = $attachment[5];
!         if ($bString) {
!           $string = $attachment[0];
!         } else {
!           $path = $attachment[0];
          }
! 
!         $inclhash = md5(serialize($attachment));
!         if (in_array($inclhash, $incl)) { continue; }
!         $incl[]      = $inclhash;
!         $filename    = $attachment[1];
!         $name        = $attachment[2];
!         $encoding    = $attachment[3];
!         $type        = $attachment[4];
!         $disposition = $attachment[6];
!         $cid         = $attachment[7];
!         if ( $disposition == 'inline' && isset($cidUniq[$cid]) ) { continue; }
!         $cidUniq[$cid] = true;
! 
!         $mime[] = sprintf("--%s%s", $boundary, $this->LE);
!         $mime[] = sprintf("Content-Type: %s; name=\"%s\"%s", $type, $this->EncodeHeader($this->SecureHeader($name)), $this->LE);
!         $mime[] = sprintf("Content-Transfer-Encoding: %s%s", $encoding, $this->LE);
! 
!         if($disposition == 'inline') {
!           $mime[] = sprintf("Content-ID: <%s>%s", $cid, $this->LE);
!         }
! 
!         $mime[] = sprintf("Content-Disposition: %s; filename=\"%s\"%s", $disposition, $this->EncodeHeader($this->SecureHeader($name)), $this->LE.$this->LE);
! 
!         // Encode as string attachment
!         if($bString) {
!           $mime[] = $this->EncodeString($string, $encoding);
!           if($this->IsError()) {
!             return '';
!           }
!           $mime[] = $this->LE.$this->LE;
!         } else {
!           $mime[] = $this->EncodeFile($path, $encoding);
!           if($this->IsError()) {
!             return '';
!           }
!           $mime[] = $this->LE.$this->LE;
          }
        }
      }
  
!     $mime[] = sprintf("--%s--%s", $boundary, $this->LE);
  
!     return implode("", $mime);
    }
  
    /**
***************
*** 1453,1462 ****
     * @param string $path The full path to the file
     * @param string $encoding The encoding to use; one of 'base64', '7bit', '8bit', 'binary', 'quoted-printable'
     * @see EncodeFile()
!    * @access private
     * @return string
     */
!   private function EncodeFile($path, $encoding = 'base64') {
      try {
        if (!is_readable($path)) {
          throw new phpmailerException($this->Lang('file_open') . $path, self::STOP_CONTINUE);
--- 1625,1634 ----
     * @param string $path The full path to the file
     * @param string $encoding The encoding to use; one of 'base64', '7bit', '8bit', 'binary', 'quoted-printable'
     * @see EncodeFile()
!    * @access protected
     * @return string
     */
!   protected function EncodeFile($path, $encoding = 'base64') {
      try {
        if (!is_readable($path)) {
          throw new phpmailerException($this->Lang('file_open') . $path, self::STOP_CONTINUE);
***************
*** 1466,1478 ****
            return false;
          }
        }
!       if (PHP_VERSION < 6) {
!         $magic_quotes = get_magic_quotes_runtime();
!         set_magic_quotes_runtime(0);
!       }
        $file_buffer  = file_get_contents($path);
        $file_buffer  = $this->EncodeString($file_buffer, $encoding);
!       if (PHP_VERSION < 6) { set_magic_quotes_runtime($magic_quotes); }
        return $file_buffer;
      } catch (Exception $e) {
        $this->SetError($e->getMessage());
--- 1638,1660 ----
            return false;
          }
        }
! 	  $magic_quotes = get_magic_quotes_runtime();
! 	  if ($magic_quotes) {
!         if (version_compare(PHP_VERSION, '5.3.0', '<')) {
!           set_magic_quotes_runtime(0);
!         } else {
! 		  ini_set('magic_quotes_runtime', 0);
! 		}
! 	  }
        $file_buffer  = file_get_contents($path);
        $file_buffer  = $this->EncodeString($file_buffer, $encoding);
! 	  if ($magic_quotes) {
!         if (version_compare(PHP_VERSION, '5.3.0', '<')) {
!           set_magic_quotes_runtime($magic_quotes);
!         } else {
! 		  ini_set('magic_quotes_runtime', $magic_quotes);
! 	    }
! 	  }
        return $file_buffer;
      } catch (Exception $e) {
        $this->SetError($e->getMessage());
***************
*** 1488,1494 ****
     * @access public
     * @return string
     */
!   public function EncodeString ($str, $encoding = 'base64') {
      $encoded = '';
      switch(strtolower($encoding)) {
        case 'base64':
--- 1670,1676 ----
     * @access public
     * @return string
     */
!   public function EncodeString($str, $encoding = 'base64') {
      $encoded = '';
      switch(strtolower($encoding)) {
        case 'base64':
***************
*** 1637,1643 ****
    * @return string
    */
    public function EncodeQPphp( $input = '', $line_max = 76, $space_conv = false) {
!     $hex = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
      $lines = preg_split('/(?:\r\n|\r|\n)/', $input);
      $eol = "\r\n";
      $escape = '=';
--- 1819,1825 ----
    * @return string
    */
    public function EncodeQPphp( $input = '', $line_max = 76, $space_conv = false) {
!     $hex = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');
      $lines = preg_split('/(?:\r\n|\r|\n)/', $input);
      $eol = "\r\n";
      $escape = '=';
***************
*** 1718,1724 ****
     * @access public
     * @return string
     */
!   public function EncodeQ ($str, $position = 'text') {
      // There should not be any EOL in the string
      $encoded = preg_replace('/[\r\n]*/', '', $str);
  
--- 1900,1906 ----
     * @access public
     * @return string
     */
!   public function EncodeQ($str, $position = 'text') {
      // There should not be any EOL in the string
      $encoded = preg_replace('/[\r\n]*/', '', $str);
  
***************
*** 1733,1739 ****
          // Replace every high ascii, control =, ? and _ characters
          //TODO using /e (equivalent to eval()) is probably not a good idea
          $encoded = preg_replace('/([\000-\011\013\014\016-\037\075\077\137\177-\377])/e',
!               "'='.sprintf('%02X', ord('\\1'))", $encoded);
          break;
      }
  
--- 1915,1921 ----
          // Replace every high ascii, control =, ? and _ characters
          //TODO using /e (equivalent to eval()) is probably not a good idea
          $encoded = preg_replace('/([\000-\011\013\014\016-\037\075\077\137\177-\377])/e',
!                                 "'='.sprintf('%02X', ord(stripslashes('\\1')))", $encoded);
          break;
      }
  
***************
*** 1807,1812 ****
--- 1989,2008 ----
      return true;
    }
  
+   public function AddStringEmbeddedImage($string, $cid, $filename = '', $encoding = 'base64', $type = 'application/octet-stream') {
+     // Append to $attachment array
+     $this->attachment[] = array(
+       0 => $string,
+       1 => $filename,
+       2 => basename($filename),
+       3 => $encoding,
+       4 => $type,
+       5 => true,  // isStringAttachment
+       6 => 'inline',
+       7 => $cid
+     );
+   }
+ 
    /**
     * Returns true if an inline attachment is present.
     * @access public
***************
*** 1821,1826 ****
--- 2017,2035 ----
      return false;
    }
  
+   public function AttachmentExists() {
+     foreach($this->attachment as $attachment) {
+       if ($attachment[6] == 'attachment') {
+         return true;
+       }
+     }
+     return false;
+   }
+ 
+   public function AlternativeExists() {
+     return strlen($this->AltBody)>0;
+   }
+ 
    /////////////////////////////////////////////////
    // CLASS METHODS, MESSAGE RESET
    /////////////////////////////////////////////////
***************
*** 1933,1942 ****
  
    /**
     * Returns the server hostname or 'localhost.localdomain' if unknown.
!    * @access private
     * @return string
     */
!   private function ServerHostname() {
      if (!empty($this->Hostname)) {
        $result = $this->Hostname;
      } elseif (isset($_SERVER['SERVER_NAME'])) {
--- 2142,2151 ----
  
    /**
     * Returns the server hostname or 'localhost.localdomain' if unknown.
!    * @access protected
     * @return string
     */
!   protected function ServerHostname() {
      if (!empty($this->Hostname)) {
        $result = $this->Hostname;
      } elseif (isset($_SERVER['SERVER_NAME'])) {
***************
*** 1950,1959 ****
  
    /**
     * Returns a message in the appropriate language.
!    * @access private
     * @return string
     */
!   private function Lang($key) {
      if(count($this->language) < 1) {
        $this->SetLanguage('en'); // set the default language
      }
--- 2159,2168 ----
  
    /**
     * Returns a message in the appropriate language.
!    * @access protected
     * @return string
     */
!   protected function Lang($key) {
      if(count($this->language) < 1) {
        $this->SetLanguage('en'); // set the default language
      }
***************
*** 1976,1985 ****
  
    /**
     * Changes every end of line from CR or LF to CRLF.
!    * @access private
     * @return string
     */
!   private function FixEOL($str) {
      $str = str_replace("\r\n", "\n", $str);
      $str = str_replace("\r", "\n", $str);
      $str = str_replace("\n", $this->LE, $str);
--- 2185,2194 ----
  
    /**
     * Changes every end of line from CR or LF to CRLF.
!    * @access public
     * @return string
     */
!   public function FixEOL($str) {
      $str = str_replace("\r\n", "\n", $str);
      $str = str_replace("\r", "\n", $str);
      $str = str_replace("\n", $this->LE, $str);
***************
*** 2001,2034 ****
     * @return $message
     */
    public function MsgHTML($message, $basedir = '') {
!     preg_match_all("/(src|background)=\"(.*)\"/Ui", $message, $images);
      if(isset($images[2])) {
        foreach($images[2] as $i => $url) {
          // do not change urls for absolute images (thanks to corvuscorax)
!         if (!preg_match('#^[A-z]+://#',$url)) {
            $filename = basename($url);
            $directory = dirname($url);
!           ($directory == '.')?$directory='':'';
            $cid = 'cid:' . md5($filename);
            $ext = pathinfo($filename, PATHINFO_EXTENSION);
            $mimeType  = self::_mime_types($ext);
!           if ( strlen($basedir) > 1 && substr($basedir,-1) != '/') { $basedir .= '/'; }
!           if ( strlen($directory) > 1 && substr($directory,-1) != '/') { $directory .= '/'; }
!           if ( $this->AddEmbeddedImage($basedir.$directory.$filename, md5($filename), $filename, 'base64',$mimeType) ) {
!             $message = preg_replace("/".$images[1][$i]."=\"".preg_quote($url, '/')."\"/Ui", $images[1][$i]."=\"".$cid."\"", $message);
            }
          }
        }
      }
      $this->IsHTML(true);
      $this->Body = $message;
!     $textMsg = trim(strip_tags(preg_replace('/<(head|title|style|script)[^>]*>.*?<\/\\1>/s','',$message)));
!     if (!empty($textMsg) && empty($this->AltBody)) {
!       $this->AltBody = html_entity_decode($textMsg);
!     }
      if (empty($this->AltBody)) {
        $this->AltBody = 'To view this email message, open it in a program that understands HTML!' . "\n\n";
      }
    }
  
    /**
--- 2210,2246 ----
     * @return $message
     */
    public function MsgHTML($message, $basedir = '') {
!     preg_match_all("/(src|background)=[\"'](.*)[\"']/Ui", $message, $images);
      if(isset($images[2])) {
        foreach($images[2] as $i => $url) {
          // do not change urls for absolute images (thanks to corvuscorax)
!         if (!preg_match('#^[A-z]+://#', $url)) {
            $filename = basename($url);
            $directory = dirname($url);
!           ($directory == '.') ? $directory='': '';
            $cid = 'cid:' . md5($filename);
            $ext = pathinfo($filename, PATHINFO_EXTENSION);
            $mimeType  = self::_mime_types($ext);
!           if ( strlen($basedir) > 1 && substr($basedir, -1) != '/') { $basedir .= '/'; }
!           if ( strlen($directory) > 1 && substr($directory, -1) != '/') { $directory .= '/'; }
!           if ( $this->AddEmbeddedImage($basedir.$directory.$filename, md5($filename), $filename, 'base64', $mimeType) ) {
!             $message = preg_replace("/".$images[1][$i]."=[\"']".preg_quote($url, '/')."[\"']/Ui", $images[1][$i]."=\"".$cid."\"", $message);
            }
          }
        }
      }
      $this->IsHTML(true);
      $this->Body = $message;
! 	if (empty($this->AltBody)) {
! 		$textMsg = trim(strip_tags(preg_replace('/<(head|title|style|script)[^>]*>.*?<\/\\1>/s', '', $message)));
! 		if (!empty($textMsg)) {
! 			$this->AltBody = html_entity_decode($textMsg, ENT_QUOTES, $this->CharSet);
! 		}
! 	}
      if (empty($this->AltBody)) {
        $this->AltBody = 'To view this email message, open it in a program that understands HTML!' . "\n\n";
      }
+ 	return $message;
    }
  
    /**
***************
*** 2192,2205 ****
     * @param string $key_pass Password for private key
     */
    public function DKIM_QP($txt) {
!     $tmp="";
!     $line="";
!     for ($i=0;$i<strlen($txt);$i++) {
!       $ord=ord($txt[$i]);
        if ( ((0x21 <= $ord) && ($ord <= 0x3A)) || $ord == 0x3C || ((0x3E <= $ord) && ($ord <= 0x7E)) ) {
!         $line.=$txt[$i];
        } else {
!         $line.="=".sprintf("%02X",$ord);
        }
      }
      return $line;
--- 2404,2417 ----
     * @param string $key_pass Password for private key
     */
    public function DKIM_QP($txt) {
!     $tmp = '';
!     $line = '';
!     for ($i = 0; $i < strlen($txt); $i++) {
!       $ord = ord($txt[$i]);
        if ( ((0x21 <= $ord) && ($ord <= 0x3A)) || $ord == 0x3C || ((0x3E <= $ord) && ($ord <= 0x7E)) ) {
!         $line .= $txt[$i];
        } else {
!         $line .= "=".sprintf("%02X", $ord);
        }
      }
      return $line;
***************
*** 2213,2220 ****
     */
    public function DKIM_Sign($s) {
      $privKeyStr = file_get_contents($this->DKIM_private);
!     if ($this->DKIM_passphrase!='') {
!       $privKey = openssl_pkey_get_private($privKeyStr,$this->DKIM_passphrase);
      } else {
        $privKey = $privKeyStr;
      }
--- 2425,2432 ----
     */
    public function DKIM_Sign($s) {
      $privKeyStr = file_get_contents($this->DKIM_private);
!     if ($this->DKIM_passphrase != '') {
!       $privKey = openssl_pkey_get_private($privKeyStr, $this->DKIM_passphrase);
      } else {
        $privKey = $privKeyStr;
      }
***************
*** 2230,2244 ****
     * @param string $s Header
     */
    public function DKIM_HeaderC($s) {
!     $s=preg_replace("/\r\n\s+/"," ",$s);
!     $lines=explode("\r\n",$s);
!     foreach ($lines as $key=>$line) {
!       list($heading,$value)=explode(":",$line,2);
!       $heading=strtolower($heading);
!       $value=preg_replace("/\s+/"," ",$value) ; // Compress useless spaces
!       $lines[$key]=$heading.":".trim($value) ; // Don't forget to remove WSP around the value
      }
!     $s=implode("\r\n",$lines);
      return $s;
    }
  
--- 2442,2456 ----
     * @param string $s Header
     */
    public function DKIM_HeaderC($s) {
!     $s = preg_replace("/\r\n\s+/", " ", $s);
!     $lines = explode("\r\n", $s);
!     foreach ($lines as $key => $line) {
!       list($heading, $value) = explode(":", $line, 2);
!       $heading = strtolower($heading);
!       $value = preg_replace("/\s+/", " ", $value) ; // Compress useless spaces
!       $lines[$key] = $heading.":".trim($value) ; // Don't forget to remove WSP around the value
      }
!     $s = implode("\r\n", $lines);
      return $s;
    }
  
***************
*** 2251,2261 ****
    public function DKIM_BodyC($body) {
      if ($body == '') return "\r\n";
      // stabilize line endings
!     $body=str_replace("\r\n","\n",$body);
!     $body=str_replace("\n","\r\n",$body);
      // END stabilize line endings
!     while (substr($body,strlen($body)-4,4) == "\r\n\r\n") {
!       $body=substr($body,0,strlen($body)-2);
      }
      return $body;
    }
--- 2463,2473 ----
    public function DKIM_BodyC($body) {
      if ($body == '') return "\r\n";
      // stabilize line endings
!     $body = str_replace("\r\n", "\n", $body);
!     $body = str_replace("\n", "\r\n", $body);
      // END stabilize line endings
!     while (substr($body, strlen($body) - 4, 4) == "\r\n\r\n") {
!       $body = substr($body, 0, strlen($body) - 2);
      }
      return $body;
    }
***************
*** 2268,2290 ****
     * @param string $subject Subject
     * @param string $body Body
     */
!   public function DKIM_Add($headers_line,$subject,$body) {
      $DKIMsignatureType    = 'rsa-sha1'; // Signature & hash algorithms
      $DKIMcanonicalization = 'relaxed/simple'; // Canonicalization of header/body
      $DKIMquery            = 'dns/txt'; // Query method
      $DKIMtime             = time() ; // Signature Timestamp = seconds since 00:00:00 - Jan 1, 1970 (UTC time zone)
      $subject_header       = "Subject: $subject";
!     $headers              = explode("\r\n",$headers_line);
      foreach($headers as $header) {
!       if (strpos($header,'From:') === 0) {
!         $from_header=$header;
!       } elseif (strpos($header,'To:') === 0) {
!         $to_header=$header;
        }
      }
!     $from     = str_replace('|','=7C',$this->DKIM_QP($from_header));
!     $to       = str_replace('|','=7C',$this->DKIM_QP($to_header));
!     $subject  = str_replace('|','=7C',$this->DKIM_QP($subject_header)) ; // Copied header fields (dkim-quoted-printable
      $body     = $this->DKIM_BodyC($body);
      $DKIMlen  = strlen($body) ; // Length of body
      $DKIMb64  = base64_encode(pack("H*", sha1($body))) ; // Base64 of packed binary SHA-1 hash of body
--- 2480,2502 ----
     * @param string $subject Subject
     * @param string $body Body
     */
!   public function DKIM_Add($headers_line, $subject, $body) {
      $DKIMsignatureType    = 'rsa-sha1'; // Signature & hash algorithms
      $DKIMcanonicalization = 'relaxed/simple'; // Canonicalization of header/body
      $DKIMquery            = 'dns/txt'; // Query method
      $DKIMtime             = time() ; // Signature Timestamp = seconds since 00:00:00 - Jan 1, 1970 (UTC time zone)
      $subject_header       = "Subject: $subject";
!     $headers              = explode($this->LE, $headers_line);
      foreach($headers as $header) {
!       if (strpos($header, 'From:') === 0) {
!         $from_header = $header;
!       } elseif (strpos($header, 'To:') === 0) {
!         $to_header = $header;
        }
      }
!     $from     = str_replace('|', '=7C', $this->DKIM_QP($from_header));
!     $to       = str_replace('|', '=7C', $this->DKIM_QP($to_header));
!     $subject  = str_replace('|', '=7C', $this->DKIM_QP($subject_header)) ; // Copied header fields (dkim-quoted-printable
      $body     = $this->DKIM_BodyC($body);
      $DKIMlen  = strlen($body) ; // Length of body
      $DKIMb64  = base64_encode(pack("H*", sha1($body))) ; // Base64 of packed binary SHA-1 hash of body
***************
*** 2303,2312 ****
      return "X-PHPMAILER-DKIM: phpmailer.worxware.com\r\n".$dkimhdrs.$signed."\r\n";
    }
  
!   protected function doCallback($isSent,$to,$cc,$bcc,$subject,$body) {
      if (!empty($this->action_function) && function_exists($this->action_function)) {
!       $params = array($isSent,$to,$cc,$bcc,$subject,$body);
!       call_user_func_array($this->action_function,$params);
      }
    }
  }
--- 2515,2524 ----
      return "X-PHPMAILER-DKIM: phpmailer.worxware.com\r\n".$dkimhdrs.$signed."\r\n";
    }
  
!   protected function doCallback($isSent, $to, $cc, $bcc, $subject, $body) {
      if (!empty($this->action_function) && function_exists($this->action_function)) {
!       $params = array($isSent, $to, $cc, $bcc, $subject, $body);
!       call_user_func_array($this->action_function, $params);
      }
    }
  }
***************
*** 2317,2320 ****
      return $errorMsg;
    }
  }
! ?>
\ No newline at end of file
--- 2529,2532 ----
      return $errorMsg;
    }
  }
! ?>
